analyze -format vhdl ./PDO12CDG.vhd
analyze -format vhdl ./PDUDGZ.vhd
analyze -format vhdl ./CA_cell.vhd
analyze -format vhdl ./FSM.vhd
analyze -format vhdl ./MUX.vhd
analyze -format vhdl ./Timeout_Gen.vhd
analyze -format vhdl ./failsafe_signal_gen.vhd
analyze -format vhdl ./failsafe_unit.vhd
analyze -format vhdl ./los_detecter.vhd
analyze -format vhdl ./pass.vhd
analyze -format vhdl ./pass2.vhd
analyze -format vhdl ./pw_checker.vhd
analyze -format vhdl ./rising_edge_bound.vhd
analyze -format vhdl ./rising_edge_diff.vhd
analyze -format vhdl ./signal_high_detect.vhd
analyze -format vhdl ./state_check.vhd
analyze -format vhdl ./timer.vhd
analyze -format vhdl ./timer_unit.vhd
analyze -format vhdl ./top_level.vhd
analyze -format vhdl ./top_level_tb_long_failsafe_signal_gen_1.vhd
analyze -format vhdl ./top_lvl.vhd
analyze -format vhdl ./top_package.vhd
analyze -format vhdl ./unglitched_input.vhd
analyze -format vhdl ./fail_top.vhd
elaborate fail_top
check_design -multiple_designs
uniquify
set_dont_touch [find cell {op* inp* pad*} -hier] true
create_clock "padClk" -period 6
current_design fail_top
compile -map_effort high -boundary_optimization
write_sdc ./Synthesized/fail_top.sdc
write -format verilog -hierarchy -output ./Synthesized/fail_top.v

report_area
report_power
report_timing -path full -delay max -max_paths 1 -nworst 1
